#ifndef __Game_h__
#define __Game_h__

#include "TextureManager.h"
#include "SDL.h"
#include "SDL_image.h"
#include "Player.h"
#include "GameObject.h"
#include "Bucket.h"
#include "Bomb.h"
#include "Background.h"

#include <iostream>
#include <vector>

using namespace std;

class Game
{
public:

    static Game* Instance()
    {
        if(s_pInstance == 0)
        {
            s_pInstance = new Game();
            return s_pInstance;
        }

        return s_pInstance;
    }

  bool init(const char* title, int xpos, int ypos, int width, int height, bool fullscreen);

  void render();
  void update();
  void handleEvents();
  void clean();
  void draw();
  unsigned int getfCount() { return m_fCount;}

  bool running() { return m_bRunning; }
  int getGameWidth() const { return m_gameWidth; }
  int getGameHeight() const { return m_gameHeight; }

  int getScaleWidth() const { return m_scaleWidth; }
  int getScaleHeight() const { return m_scaleHeight; }

private:

  Game();
  ~Game();

  // store the game width and height
  int m_gameWidth;
  int m_gameHeight;

  SDL_Window* m_pWindow;
  SDL_Renderer* m_pRenderer;

	//SDL_Texture* m_pTexture; // the new SDL_Texture variable
	//SDL_Rect m_sourceRectangle; // the first rectangle
	//SDL_Rect m_destinationRectangle; // another rectangle

  int m_currentFrame;
  //TextureManager m_textureManager;

  bool m_bRunning;

  static Game* s_pInstance;

  unsigned int m_fCount;

	GameObject* m_bomber;

	Background* m_background;
	GameObject* m_rect;
	GameObject* fly_num;
	Bucket* m_bucket1;
	Bucket* m_bucket2;
	Bucket* m_bucket3;
	Bomb* m_bomb;
	int m_scaleHeight;
	int m_scaleWidth;

  std::vector<GameObject*> m_gameObjects;
  std::vector<Bucket*> m_buckets;


};

typedef Game TheGame;

#endif
